/******************************************************************************
*                              Steffen Hofmann                                *
*                                 Hamburg                                     *
*                               mc_sho@gmx.de                                 *
*******************************************************************************
*  $Source: $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  08.07.2003
*  Geraete Bezeichnung   :  MEGA-128-BOARD
*-----------------------------------------------------------------------------*
*- $Id: $
*-----------------------------------------------------------------------------*
*
*       Headerfile
*       ----------
*       Baugruppen IDs
*       V1.00
******************************************************************************/

#ifndef BAUGRID_H
#define BAUGRID_H

//- Baugruppen IDs ------------------------------------------------------------
//*****************************************************************************
//   ACHTUNG: bitte fr weitere IDs immer nur neue Zahlenwerte vergeben !!!!!!!
//*****************************************************************************
typedef enum{
   BROADCAST_ID                 =0,     // Broadcast ID
   MOTOR_ID                     =1,     // Baugruppe Motor
   TEMPERATUR1_ID               =2,     // Baugruppe Temperatur1
   LCD_ID                       =3,     // LCD Anzeige
   BEEP_ID                      =4,     // Beeper
   
   MAX_BRG                      =0xFF
} BaugrID;

//- CAN Bus Modul Nummern -----------------------------------------------------
//*****************************************************************************
//   ACHTUNG: bitte fr weitere IDs immer nur neue Zahlenwerte vergeben !!!!!!!
//*****************************************************************************

enum CANModulNr {
  PC_BEDIENUNG_CAN_NR   =0,   // LP Bedienung PC
  MODUL_KUECHE          =1,   // CAN-Modul was in der Kueche laeuft
  MODUL_STUBE           =2,   // CAN-Modul was in der Stube laeuft
  MODUL_FMUSTER         =3,   // Testleiterplatte
  MODUL_32BOARD         =4,   // noch eine Leiterplatte als Modul
  
  MAX_CAN_MODUL         =0xFF
};
#endif