/******************************************************************************
*                              Steffen Hofmann                                *
*                                 Hamburg                                     *
*                               mc_sho@gmx.de                                 *
*******************************************************************************
*  $Source: $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  08.07.2003
*  Geraete Bezeichnung   :  MEGA-128-BOARD
*-----------------------------------------------------------------------------*
*- $Id: $
*-----------------------------------------------------------------------------*
*
*       Headerfile
*       ----------
*       Canprotokoll
*       V1.00
******************************************************************************/
#ifndef CANPROTOKOLL_H
#define CANPROTOKOLL_H

#include "types.h"
#include "canbus.h"

//-----------------------------------------------------------------------------
//  Definition Nachrichtenaustausch 
//-----------------------------------------------------------------------------
#define ACK		0x13	// acknowledge ( positive Antwort )
#define NAK		0x14	// negative acknowledge ( negative Antwort )
#define ZVB		0x15	// zuviele Bytes im ersten Frame angegeben 
#define TMO		0x16	// Timeout
#define ERW		0x17	// Warning! 128x gesendet und Fehler 
#define KAW		0x18	// keine Antwort mehr vom Master
#define CAN_WAIT	0x19	// noch nicht bereit zum empfang, nach x ms nochmal versuchen
#define CTS		0x11	// Clear To Send
#define RTS		0x10	// Request To Send

#define CA		0xFF	// Connection Abort


//-----------------------------------------------------------------------------
//  Nachrichtenbuffer
//-----------------------------------------------------------------------------
struct CANBuffer {
 	BYTE ByteCount;
 	BYTE TR_Buffer[1];
};

#define MAX_CAN_FUNC  25

typedef void (*voidFuncPtr)(void);
volatile static voidFuncPtr CANFunc[MAX_CAN_FUNC];

//-----------------------------------------------------------------------------
//  Funktionen
//-----------------------------------------------------------------------------
BYTE InitMsg( BYTE i_prio, BYTE i_source, BYTE i_desti, void (*userFunc)(void) );

BYTE transmit( void* buffer, BYTE timout );

BYTE receive( void* buffer, BYTE timeout );

void changeMsg( BYTE i_prio, BYTE i_source, BYTE i_desti, void (*userFunc)(void) );

#endif