/******************************************************************************
*                              Steffen Hofmann                                *
*                                 Hamburg                                     *
*                               mc_sho@gmx.de                                 *
*******************************************************************************
*  $Source: $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  08.07.2003
*  Geraete Bezeichnung   :  MEGA-128-BOARD
*-----------------------------------------------------------------------------*
*- $Id: $
*-----------------------------------------------------------------------------*
*
*       Headerfile
*       ----------
*       Fr Hardware Festlegungen des Projekts
*       V1.00
******************************************************************************/


#ifndef _HW_H_
#define _HW_H_


#include <iom128v.h>

//- Belegung der Prozessorports -----------------------------------------------
//                                        option
// PA0  frei                              ----
// PA1  frei                              ----
// PA2  frei                              ---- 
// PA3  frei                              ----
// PA4  frei                              ----
// PA5  frei                              ----
// PA6  frei                              ----
// PA7  frei                              ----
//
// PB0  frei                              /SS  SPI Slave
// PB1  frei                              SCK  SPI
// PB2  frei                              MOSI SPI
// PB3  frei                              MISO SPI
// PB4  frei                              OC0
// PB5  frei                              OC1A
// PB6  frei                              OC1B
// PB7  frei                              OC2/OC1B
//
// PC0  frei                              ----
// PC1  frei                              ----
// PC2  frei                              ----
// PC3  frei                              ----
// PC4  frei                              ----
// PC5  frei                              ----
// PC6  frei                              ----
// PC7  frei                              ----
//
// PD0  frei                              SCL/INT0
// PD1  frei                              SDA/INT1
// PD2  frei                              RXD1/INT2
// PD3  frei                              TXD1/INT3
// PD4  frei                              IC1
// PD5  CS-CAN                            XCK1
// PD6  frei                              T1
// PD7  frei                              T2
//
// PE0  frei                              RXD0/PDI
// PE1  frei                              TXD0/PDO
// PE2  frei                              XCK0/AIN0
// PE3  frei                              OC3A/AIN1
// PE4  frei                              OC3B/INT4
// PE5  frei                              OC3C/INT5
// PE6  frei                              T3/INT6
// PE7  frei                              IC3/INT7


// PF0  frei                              ADC0
// PF1  frei                              ADC1
// PF2  frei                              ADC2
// PF3  frei                              ADC3
// PF4  frei                              ADC4/TCK
// PF5  frei                              ADC5/TMS
// PF6  frei                              ADC6/TDO
// PF7  frei                              ADC7/TDI

//
// PG0  frei                              /WR nur mit exteren SRAM
// PG1  frei                              /RD nur mit externen SRAM
// PG2  frei                              ALE nur mit exteren SRAM
// PG3  frei                              TOSC2 / RTC
// PG4  frei                              TOSC1 / RTC



//- Belegung der Interrupt-Vektoren -------------------------------------------
//
// INT0  frei
// INT1  frei
// INT2  frei
// INT3  frei
// INT4  frei
// INT5  frei
// INT6  frei
// INT7  frei
//
//- Timings -------------------------------------------------------------------

//#define F_CPU  800000     // 8MHz

//- Belegung Portbits und Ports
//
//- Ports
#define CAN_PORT_CS  PORTD
#define CS_CAN       5
//- Bits




//- Config SPI ----------------------------------------------------------------
//
//                                SPIE = 1 int enable, SPIE = 0 int disable
//                                SPE  = 1 SPI enable, SPE  = 0 SPI disable
//                                DORD = 1 shift LSB,  DORD = 0 shift MSB
//                                MSTR = 1 SPI Master, MSTR = 0 SPI Slave
                                   
//                                SPIE  SPE  DORD  MSTR  CPOL  CPHA  SPR1  SPR0 
#define SPI_KONTRAST 0x70       //  0    1    1     1      0     0    0      0
#define SPI_4094     0x5C       //  0    1    0     1      1     1    0      0
#define SPI_MCP_WR   0x50       //  0    1    0     1      0     0    0      0
#define SPI_TLV5638  0x5C       //  0    1    0     1      1     1    0      0
#define SPI_ADS8341_W 0x54      //  0    1    0     1      0     1    0      0
#define SPI_ADS8341_R 0x50      //  0    1    0     1      0     0    0      0
#define SPI_MMC       0x5C      //  0    1    0     1      1     1    0      0



#endif