/******************************************************************************
*                              Steffen Hofmann                                *
*                                 Hamburg                                     *
*                               mc_sho@gmx.de                                 *
*******************************************************************************
*  $Source: $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  08.07.2003
*  Geraete Bezeichnung   :  MEGA-128-BOARD
*-----------------------------------------------------------------------------*
*- $Id: $
*-----------------------------------------------------------------------------*
*
*       Headerfile
*       ----------
*       mega128board.h
*       V1.00
******************************************************************************/
#ifndef _MEGA_128_BOARD_H_
#define _MEGA_128_BOARD_H_

// CPU clock speed
//#define F_CPU        16000000               		// 16MHz processor
//#define F_CPU        14745000               		// 14.745MHz processor
#define F_CPU        8000000               		 // 8MHz processor
//#define F_CPU        7372800               		   // 7.37MHz processor
//#define F_CPU        4000000               		 // 4MHz processor
//#define F_CPU        3686400               		 // 3.69MHz processor
#define CYCLES_PER_US ((F_CPU+500000)/1000000) 	// cpu cycles per microsecond

#define F_Freq (F_CPU/100L)

//  time
#define T_Time_us 1       // 1 s
#define T_Time_ms 1000    // 1 ms

        #if (((F_Freq * T_Time_us)/10000L) < 256)
         #define F_Div_us 1L
         #define F_TCCR0_Set_us 1
        #elif ((((F_Freq/8L) * T_Time_us)/10000L) < 256)
         #define F_Div_us 8L
         #define F_TCCR0_Set_us 2
        #elif ((((F_Freq/64L) * T_Time_us)/10000L) < 256)
         #define F_Div_us 64L
         #define F_TCCR0_Set_us 3
        #elif ((((F_Freq/256L) * T_Time_us)/10000L) < 256)
         #define F_Div_us 256L
         #define F_TCCR0_Set_us 4
        #elif ((((F_Freq/1024L) * T_Time_us)/10000L) < 256)
         #define F_Div_us 1024L
         #define F_TCCR0_Set_us 5
         #else
         #error " s unable to calculate timer constants"
        #endif
        
        #if (((F_Freq * T_Time_ms)/10000L) < 256)
         #define F_Div_ms 1L
         #define F_TCCR0_Set_ms 1
        #elif ((((F_Freq/8L) * T_Time_ms)/10000L) < 256)
         #define F_Div_ms 8L
         #define F_TCCR0_Set_ms 2
        #elif ((((F_Freq/64L) * T_Time_ms)/10000L) < 256)
         #define F_Div_ms 64L
         #define F_TCCR0_Set_ms 3
        #elif ((((F_Freq/256L) * T_Time_ms)/10000L) < 256)
         #define F_Div_ms 256L
         #define F_TCCR0_Set_ms 4
        #elif ((((F_Freq/1024L) * T_Time_ms)/10000L) < 256)
         #define F_Div_ms 1024L
         #define F_TCCR0_Set_ms 5
         #else
         #error " ms unable to calculate timer constants"
        #endif
         
#define T_Reload_Set_us 256L-(((F_Freq/F_Div_us) * T_Time_us)/10000L)
#define T_Reload_Set_ms 256L-(((F_Freq/F_Div_ms) * T_Time_ms)/10000L)         
         


#endif