/******************************************************************************
*                              Steffen Hofmann                                *
*                                 Hamburg                                     *
*                               mc_sho@gmx.de                                 *
*******************************************************************************
*  $Source: $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  08.07.2003
*  Geraete Bezeichnung   :  MEGA-128-BOARD
*-----------------------------------------------------------------------------*
*- $Id: $
*-----------------------------------------------------------------------------*
*
*       Headerfile
*       ----------
*       Fuer allgemeine Dinge des Projekts
*       V1.00
******************************************************************************/

#ifndef TYPES_H
#define TYPES_H

//allgemeine Define's *********************************************************

//- Datentypen ----------------------------------------------------------------


#ifndef BOOL
typedef unsigned char BOOL;
#endif

#ifndef INLINE
#define INLINE
#endif

#ifndef NULL
#define NULL 0
#endif

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

#define LOW(x)  ((short)x & 0x0FF)
#define HIGH(x) ((short)x >> 8)
#define BSW(x)	((((x) >> 8) & 0x00FF) | (((x) << 8) & 0xFF00))

#define MINIMUM(x,y) ((x<y) ? x : y)
#define MAXIMUM(x,y) ((x>y) ? x : y)

typedef enum {
   EIN,                      // Schalter ein
   AUS                        // Schalter aus
   } Schalter;

#ifndef __C51__
typedef unsigned long DWORD;	//   Type DWORD definition
#endif

#ifndef WORD
typedef unsigned short WORD;	//   Type WORD definition
#endif

#ifndef SHORT
typedef short SHORT;	         //   Type SHORT definition
#endif

#ifndef CHAR
typedef char CHAR;	         //   Type CHAR definition
#endif

typedef unsigned char BYTE;	//   Type BYTE definition

/* enable global interrupts */
#define GIE      	        	   (SREG |= BIT(7))

/* disable global interrupts */
#define GID       	         	   (SREG &= ~BIT(7))

#define SLEEP()	asm("sleep")

#ifndef BV
  #define BV(x) (1 << (x))
#endif

/* enables an unsigned char to be used as a series of booleans */
#define BIT(x)	           (1 << (x))
#define SETBIT(x, y)   	   (x |= y)
#define CLEARBIT(x, y) 	   (x &= ~y)
#define CHECKBIT(x, y) 	   (x & y)
#define SBI(x,y)           (x |= BIT(y))
#define CBI(x,y)           (x &= BIT(~y))


#endif
