	.module mcp2515.c
	.area text(rom, con, rel)
	.dbfile C:\icc\examples.avr\MCP2515\source\mcp2515.c
	.dbfunc e CAN_ModifyRegister _CAN_ModifyRegister fV
;       regvalue -> y+4
;           mask -> R10
;        regaddr -> R12
	.even
_CAN_ModifyRegister::
	xcall push_gset4x
	mov R10,R18
	mov R12,R16
	.dbline -1
	.dbline 57
; /******************************************************************************
; *                              Steffen Hofmann                                *
; *                                 Hamburg                                     *
; *                               mc_sho@gmx.de                                 *
; *******************************************************************************
; *  $Source: $
; *-----------------------------------------------------------------------------*
; *  Datum der 1. Version  :  08.07.2003
; *  Geraete Bezeichnung   :  MEGA-128-BOARD
; *-----------------------------------------------------------------------------*
; *- $Id: $
; *-----------------------------------------------------------------------------*
; *
; *       Source
; *       ----------
; *       mcp2515.c
; *       V1.00
; ******************************************************************************/
; 
; #include "hw.h"
; #include "mcp2515.h"
; #include "spi.h"
; #include "types.h"
; 
; #ifdef PR_RTX
; #include "task.h"
; #include "pr_rtx_macros_defs.h"
; #else
; #include "timer.h"
; #endif
; 
; //-----------------------------------------------------------------------------
; //- extern
; //-----------------------------------------------------------------------------
; 
; 
; //-----------------------------------------------------------------------------
; //- locale functionen
; //-----------------------------------------------------------------------------
; void SPI_mcp_select (void);
; void SPI_mcp_unselect (void);
; void CAN_ModifyRegister ( BYTE regaddr, BYTE mask, BYTE regvalue);
; void CAN_Reset( void );
; BYTE CAN_ReadRegister( BYTE regaddr );
; void CAN_ReadManyRegisters( BYTE regaddr, BYTE len, BYTE *dta );
; void CAN_WriteRegister( BYTE regaddr, BYTE regvalue );
; void CAN_WriteManyRegisters( BYTE regaddr, BYTE len, BYTE *dta );
; void CAN_Mode (BYTE Mode);
; 
; static BYTE RettConf;
; 
; //-----------------------------------------------------------------------------
; // function:	ModifyRegister
; // description:	Modify one MCP2515 register.
; //-----------------------------------------------------------------------------
; void CAN_ModifyRegister ( BYTE regaddr, BYTE mask, BYTE regvalue)
; {
	.dbline 59
; 
;    SPI_mcp_select();	// Select the MCP2515
	xcall _SPI_mcp_select
	.dbline 60
;    SpiWriteByte( MCP_BITMOD );
	ldi R16,5
	xcall _SpiWriteByte
	.dbline 61
;    SpiWriteByte( regaddr );
	mov R16,R12
	xcall _SpiWriteByte
	.dbline 62
;    SpiWriteByte( mask );
	mov R16,R10
	xcall _SpiWriteByte
	.dbline 63
;    SpiWriteByte( regvalue );
	ldd R16,y+4
	xcall _SpiWriteByte
	.dbline 64
;    SPI_mcp_unselect();	// Deselect the MCP2515
	xcall _SPI_mcp_unselect
	.dbline 70
; 
; #ifdef PR_RTX
;    PR_Wait_Ticks( 10 );		// short delay
; #else
;    
;    wait_ms( 1 );
	ldi R16,1
	ldi R17,0
	xcall _wait_ms
	.dbline -2
L2:
	xcall pop_gset4x
	.dbline 0 ; func end
	ret
	.dbsym l regvalue 4 c
	.dbsym r mask 10 c
	.dbsym r regaddr 12 c
	.dbend
	.dbfunc e CAN_State _CAN_State fc
;           rreg -> R10
	.even
_CAN_State::
	xcall push_gset3x
	.dbline -1
	.dbline 79
; #endif
; }
; 
; //-----------------------------------------------------------------------------
; // function:	State
; // description:	Reads state of MCP2515 over SPI.
; //-----------------------------------------------------------------------------
; BYTE CAN_State (void)
; {
	.dbline 82
;    BYTE rreg;
;    
;    SPI_mcp_select();	            // Select the MCP2515
	xcall _SPI_mcp_select
	.dbline 83
;    SpiWriteByte( MCP_READ_STATUS );	 
	ldi R16,160
	xcall _SpiWriteByte
	.dbline 84
;    rreg = SpiReadByte();	        // Read back the register
	xcall _SpiReadByte
	mov R10,R16
	.dbline 85
;    SPI_mcp_unselect();	          // Deselect the MCP2515
	xcall _SPI_mcp_unselect
	.dbline 91
; 
; #ifdef PR_RTX
;    PR_Wait_Ticks( 10 );		        // short delay
; #else
;    
;    wait_ms( 1 );
	ldi R16,1
	ldi R17,0
	xcall _wait_ms
	.dbline 94
; #endif
;    
;    return rreg;
	mov R16,R10
	.dbline -2
L3:
	xcall pop_gset3x
	.dbline 0 ; func end
	ret
	.dbsym r rreg 10 c
	.dbend
	.dbfunc e CAN_Reset _CAN_Reset fV
	.even
_CAN_Reset::
	.dbline -1
	.dbline 102
; }
; 
; //-----------------------------------------------------------------------------
; // function:	ResetMCP2515
; // description:	Reset the MCP2515.
; //-----------------------------------------------------------------------------
; void CAN_Reset( void )
; {
	.dbline -2
L4:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e CAN_ReadRegister _CAN_ReadRegister fc
;           rreg -> R10
;        regaddr -> R10
	.even
_CAN_ReadRegister::
	xcall push_gset3x
	mov R10,R16
	.dbline -1
	.dbline 124
; #ifdef CAN_EXT_RESET
; 
;    CBI( RES_PORT, RES_CAN);  //- RES_CAN low
; 	  
; 
; #ifdef PR_RTX
;    PR_Wait_Ticks( 10 );		              // short delay
; #else
;    
;    wait_ms( 250 );
; #endif
;    
;    SBI( RES_PORT, RES_CAN);  //- RES_CAN high
; #endif	  
; }
; 
; //-----------------------------------------------------------------------------
; // function:	ReadRegister
; // description:	Read 1 register from the MCP2515 over SPI.
; //-----------------------------------------------------------------------------
; BYTE CAN_ReadRegister( BYTE regaddr )
; {
	.dbline 127
;    BYTE rreg;
;    
;    SPI_mcp_select();	        // Select the MCP2515
	xcall _SPI_mcp_select
	.dbline 128
;    SpiWriteByte( MCP_READ );	// Send the Read command
	ldi R16,3
	xcall _SpiWriteByte
	.dbline 129
;    SpiWriteByte( regaddr );	// Send the register
	mov R16,R10
	xcall _SpiWriteByte
	.dbline 130
;    rreg = SpiReadByte();	// Read back the register
	xcall _SpiReadByte
	mov R10,R16
	.dbline 131
;    SPI_mcp_unselect();	        // Deselect the MCP2515
	xcall _SPI_mcp_unselect
	.dbline 137
; 
; #ifdef PR_RTX
;    PR_Wait_Ticks( 10 );		    // short delay
; #else
;    
;    wait_ms( 1 );
	ldi R16,1
	ldi R17,0
	xcall _wait_ms
	.dbline 140
; #endif
; 
;    return rreg;
	mov R16,R10
	.dbline -2
L5:
	xcall pop_gset3x
	.dbline 0 ; func end
	ret
	.dbsym r rreg 10 c
	.dbsym r regaddr 10 c
	.dbend
	.dbfunc e CAN_ReadManyRegisters _CAN_ReadManyRegisters fV
;              x -> R10
;            dta -> R12,R13
;            len -> R14
;        regaddr -> R10
	.even
_CAN_ReadManyRegisters::
	xcall push_gset5x
	mov R14,R18
	mov R10,R16
	ldd R12,y+6
	ldd R13,y+7
	.dbline -1
	.dbline 149
; }
; 
; //-----------------------------------------------------------------------------
; // function:	ReadManyRegister
; // description:	Read multiple registers from the
; //		MCP2515 over SPI.
; //-----------------------------------------------------------------------------
; void CAN_ReadManyRegisters( BYTE regaddr, BYTE len, BYTE *dta )
; {
	.dbline 153
; 
;    BYTE x;
;    
;    SPI_mcp_select();         // Select the MCP2515
	xcall _SPI_mcp_select
	.dbline 154
;    SpiWriteByte( MCP_READ );	// Send the Read command
	ldi R16,3
	xcall _SpiWriteByte
	.dbline 155
;    SpiWriteByte( regaddr );	 // Send the register
	mov R16,R10
	xcall _SpiWriteByte
	.dbline 156
;    for( x=0; x<len; x++ )
	clr R10
	xjmp L10
L7:
	.dbline 157
	.dbline 158
	xcall _SpiReadByte
	movw R30,R12
	std z+0,R16
	.dbline 159
	movw R24,R30
	adiw R24,1
	movw R12,R24
	.dbline 160
L8:
	.dbline 156
	inc R10
L10:
	.dbline 156
	cp R10,R14
	brlo L7
	.dbline 161
;    {
;       *dta = SpiReadByte( );
;        dta++;
;    }
;    SPI_mcp_unselect();  	    // Deselect the MCP2515
	xcall _SPI_mcp_unselect
	.dbline 167
; 
; #ifdef PR_RTX
;    PR_Wait_Ticks( 10 );		    // short delay
; #else
;    
;    wait_ms( 1 );
	ldi R16,1
	ldi R17,0
	xcall _wait_ms
	.dbline -2
L6:
	xcall pop_gset5x
	.dbline 0 ; func end
	ret
	.dbsym r x 10 c
	.dbsym r dta 12 pc
	.dbsym r len 14 c
	.dbsym r regaddr 10 c
	.dbend
	.dbfunc e CAN_WriteRegister _CAN_WriteRegister fV
;       regvalue -> R10
;        regaddr -> R12
	.even
_CAN_WriteRegister::
	xcall push_gset4x
	mov R10,R18
	mov R12,R16
	.dbline -1
	.dbline 176
; #endif
; }
; 
; //-----------------------------------------------------------------------------
; // function:	WriteRegister
; // description:	Write 1 MCP2515 register.
; //-----------------------------------------------------------------------------
; void CAN_WriteRegister( BYTE regaddr, BYTE regvalue )
; {
	.dbline 178
; 
;    SPI_mcp_select();              // Select the MCP2515
	xcall _SPI_mcp_select
	.dbline 179
;    SpiWriteByte( MCP_WRITE );
	ldi R16,2
	xcall _SpiWriteByte
	.dbline 180
;    SpiWriteByte( regaddr );
	mov R16,R12
	xcall _SpiWriteByte
	.dbline 181
;    SpiWriteByte( regvalue );
	mov R16,R10
	xcall _SpiWriteByte
	.dbline 182
;    SPI_mcp_unselect();            // Deselect the MCP2515
	xcall _SPI_mcp_unselect
	.dbline 188
; 
; #ifdef PR_RTX
;    PR_Wait_Ticks( 10 );		    // short delay
; #else
;    
;    wait_ms( 1 );
	ldi R16,1
	ldi R17,0
	xcall _wait_ms
	.dbline -2
L11:
	xcall pop_gset4x
	.dbline 0 ; func end
	ret
	.dbsym r regvalue 10 c
	.dbsym r regaddr 12 c
	.dbend
	.dbfunc e CAN_WriteManyRegisters _CAN_WriteManyRegisters fV
;              x -> R10
;            dta -> R12,R13
;            len -> R14
;        regaddr -> R10
	.even
_CAN_WriteManyRegisters::
	xcall push_gset5x
	mov R14,R18
	mov R10,R16
	ldd R12,y+6
	ldd R13,y+7
	.dbline -1
	.dbline 197
; #endif
; }
; 
; //-----------------------------------------------------------------------------
; // function:	WriteManyRegisters
; // description:	Write multiple MCP2515 registers.
; //-----------------------------------------------------------------------------
; void CAN_WriteManyRegisters( BYTE regaddr, BYTE len, BYTE *dta )
; {
	.dbline 201
; 
;    BYTE x;
;    
;    SPI_mcp_select(); ;	// Select the MCP2515
	xcall _SPI_mcp_select
	.dbline 201
	.dbline 202
;    SpiWriteByte( MCP_WRITE );	// Send the Read command
	ldi R16,2
	xcall _SpiWriteByte
	.dbline 203
;    SpiWriteByte( regaddr );	// Send the register
	mov R16,R10
	xcall _SpiWriteByte
	.dbline 204
;    for( x=0; x<len; x++ )
	clr R10
	xjmp L16
L13:
	.dbline 205
	.dbline 206
	movw R30,R12
	ldd R16,z+0
	xcall _SpiWriteByte
	.dbline 207
	movw R24,R12
	adiw R24,1
	movw R12,R24
	.dbline 208
L14:
	.dbline 204
	inc R10
L16:
	.dbline 204
	cp R10,R14
	brlo L13
	.dbline 209
;    {
;       SpiWriteByte( *dta );
;       dta++;
;    }
;    SPI_mcp_unselect();	// Deselect the MCP2515
	xcall _SPI_mcp_unselect
	.dbline 215
; 
; #ifdef PR_RTX
;    PR_Wait_Ticks( 10 );		    // short delay
; #else
;    
;    wait_ms( 1 );
	ldi R16,1
	ldi R17,0
	xcall _wait_ms
	.dbline -2
L12:
	xcall pop_gset5x
	.dbline 0 ; func end
	ret
	.dbsym r x 10 c
	.dbsym r dta 12 pc
	.dbsym r len 14 c
	.dbsym r regaddr 10 c
	.dbend
	.dbfunc e CAN_Mode _CAN_Mode fV
;           Mode -> R10
	.even
_CAN_Mode::
	xcall push_gset3x
	mov R10,R16
	.dbline -1
	.dbline 224
; #endif
; }
; 
; //-----------------------------------------------------------------------------
; // function:	Switching between the MCP Modes
; // description:	
; //-----------------------------------------------------------------------------
; void CAN_Mode (BYTE Mode)
; {
	.dbline 225
;    CAN_WriteRegister (MCP_CANCTRL,Mode);
	mov R18,R10
	ldi R16,15
	xcall _CAN_WriteRegister
	.dbline -2
L17:
	xcall pop_gset3x
	.dbline 0 ; func end
	ret
	.dbsym r Mode 10 c
	.dbend
	.dbfunc e CAN_Init _CAN_Init fV
;            idh -> <dead>
;            idl -> <dead>
;      CNF3_data -> y+12
;      CNF2_data -> y+10
;      CNF1_data -> y+8
;             ID -> y+4
	.even
_CAN_Init::
	xcall push_arg4
	sbiw R28,4
	.dbline -1
	.dbline 233
; }
; 
; //-----------------------------------------------------------------------------
; // function:	Initalization of the MCP2515 (Normal Operation Mode)
; // description:	
; //-----------------------------------------------------------------------------
; void CAN_Init (DWORD ID,BYTE CNF1_data,BYTE CNF2_data,BYTE CNF3_data)
; {
	.dbline 237
;   WORD idl,idh;
;   
;   //- Reset MCP2515
;   CAN_Reset ();
	xcall _CAN_Reset
	.dbline 239
;   //- MCP2515 in Config Mode
;   CAN_Mode (MODE_CONFIG);              
	ldi R16,128
	xcall _CAN_Mode
	.dbline 241
;   //- Baudrate
;   CAN_WriteRegister (MCP_CNF1,CNF1_data);  //CNF1  Configuration Registers..
	ldd R18,y+8
	ldi R16,42
	xcall _CAN_WriteRegister
	.dbline 242
;   CAN_WriteRegister (MCP_CNF2,CNF2_data);  //CNF2
	ldd R18,y+10
	ldi R16,41
	xcall _CAN_WriteRegister
	.dbline 243
;   CAN_WriteRegister (MCP_CNF3,( CNF3_data | SOF_DISABLE | WAKFIL_DISABLE ));  //CNF3
	ldd R18,y+12
	ldi R16,40
	xcall _CAN_WriteRegister
	.dbline 245
;   //- drei TX als Eingaenge
;   CAN_WriteRegister (MCP_TXRTSCTRL,(TXRTSCTRL_B2RTSM | TXRTSCTRL_B1RTSM | TXRTSCTRL_B0RTSM)); 
	ldi R18,7
	ldi R16,13
	xcall _CAN_WriteRegister
	.dbline 247
; 
;   CAN_WriteRegister ( MCP_RXB0CTRL, RXB0CTRL_RXM_OFF );
	ldi R18,96
	ldi R16,96
	xcall _CAN_WriteRegister
	.dbline 248
;   CAN_WriteRegister ( MCP_RXB1CTRL, RXB1CTRL_RXM_OFF );
	ldi R18,96
	ldi R16,112
	xcall _CAN_WriteRegister
	.dbline 251
; 
;     // Mark all filter bits as don't care:
;     CAN_Write_Can_ID(MCP_RXM0SIDH, CAN_EXT_ID, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	ldi R18,1
	ldi R16,32
	xcall _CAN_Write_Can_ID
	.dbline 252
;     CAN_Write_Can_ID(MCP_RXM1SIDH, CAN_EXT_ID, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	ldi R18,1
	ldi R16,36
	xcall _CAN_Write_Can_ID
	.dbline 254
;     // Anyway, set all filters to 0:
;     CAN_Write_Can_ID(RXB1CTRL_FILHIT_RXF0, CAN_NO_EXT_ID, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	clr R18
	clr R16
	xcall _CAN_Write_Can_ID
	.dbline 255
;     CAN_Write_Can_ID(RXB1CTRL_FILHIT_RXF1, CAN_NO_EXT_ID, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	clr R18
	ldi R16,1
	xcall _CAN_Write_Can_ID
	.dbline 256
;     CAN_Write_Can_ID(RXB1CTRL_FILHIT_RXF2, CAN_NO_EXT_ID, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	clr R18
	ldi R16,2
	xcall _CAN_Write_Can_ID
	.dbline 257
;     CAN_Write_Can_ID(RXB1CTRL_FILHIT_RXF3, CAN_NO_EXT_ID, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	clr R18
	ldi R16,3
	xcall _CAN_Write_Can_ID
	.dbline 258
;     CAN_Write_Can_ID(RXB1CTRL_FILHIT_RXF4, CAN_NO_EXT_ID, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	clr R18
	ldi R16,4
	xcall _CAN_Write_Can_ID
	.dbline 259
;     CAN_Write_Can_ID(RXB1CTRL_FILHIT_RXF5, CAN_NO_EXT_ID, 0);
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	std y+0,R24
	std y+1,R25
	std y+2,R26
	std y+3,R27
	clr R18
	ldi R16,5
	xcall _CAN_Write_Can_ID
	.dbline 282
;     
; /*  MCP_WriteRegister (RXM0SIDH,0x03);         //MASK  unterste 5 Bits auswerten
;   MCP_WriteRegister (RXM0SIDL,0xE0);         //MASK
;   MCP_WriteRegister (RXM1SIDH,0x03);         //MASK 
;   MCP_WriteRegister (RXM1SIDL,0xE0);         //MASK
; 
;   MCP_WriteRegister (RXF0SIDH,0x00);         // Recieve Filters
;   MCP_WriteRegister (RXF0SIDL,0x00);         //....
;   idh = ((ID & 0x07F8) >> 3);
;   idl = ((ID & 0x0007) << 5);
;   MCP_WriteRegister (RXF1SIDH,idh); //
;   MCP_WriteRegister (RXF1SIDL,idl); //
;   MCP_WriteRegister (RXF2SIDH,0x00);         // alle anderen nur NOTAUS
;   MCP_WriteRegister (RXF2SIDL,0x00);
;   MCP_WriteRegister (RXF3SIDH,0x00);
;   MCP_WriteRegister (RXF3SIDL,0x00);
;   MCP_WriteRegister (RXF4SIDH,0x00);
;   MCP_WriteRegister (RXF4SIDL,0x00);
;   MCP_WriteRegister (RXF5SIDH,0x00);
;   MCP_WriteRegister (RXF5SIDL,0x00);*/
; 
;   //CAN_WriteRegister (MCP_CANINTE, CANINTE_RX1IE + CANINTE_RX0IE ); // Enable Receive interrups
;   CAN_WriteRegister (MCP_CANINTE,CANINTF_ALL_DISABLE ); 
	clr R18
	ldi R16,43
	xcall _CAN_WriteRegister
	.dbline 283
;   CAN_WriteRegister (MCP_BFPCTRL,(RXnBF_B0BFM |  // RX0 not Ints
	ldi R18,15
	ldi R16,12
	xcall _CAN_WriteRegister
	.dbline 289
;                                   RXnBF_B1BFM |  // RX1 not Ints
;                                   RXnBF_B0BFE |
;                                   RXnBF_B1BFE ));
;                                   
;                                   
;   CAN_Mode(MODE_NORMAL);              // Normal Mode
	clr R16
	xcall _CAN_Mode
	.dbline -2
L18:
	adiw R28,8
	.dbline 0 ; func end
	ret
	.dbsym l idh 5 s
	.dbsym l idl 5 s
	.dbsym l CNF3_data 12 c
	.dbsym l CNF2_data 10 c
	.dbsym l CNF1_data 8 c
	.dbsym l ID 4 l
	.dbend
	.dbfunc e CAN_Sleep _CAN_Sleep fV
	.even
_CAN_Sleep::
	.dbline -1
	.dbline 298
; 
; }
; 
; //-----------------------------------------------------------------------------
; // function:	Goto Sleep Mode
; // description:	
; //-----------------------------------------------------------------------------
; void CAN_Sleep ( void )
; {
	.dbline 299
;   CAN_WriteRegister(MCP_CANINTE, CANINTE_WAKIE ); 
	ldi R18,64
	ldi R16,43
	xcall _CAN_WriteRegister
	.dbline 300
;   CAN_Mode(MODE_SLEEP);
	ldi R16,32
	xcall _CAN_Mode
	.dbline -2
L19:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e CAN_Wake_up _CAN_Wake_up fV
	.even
_CAN_Wake_up::
	.dbline -1
	.dbline 309
; }
; 
; //-----------------------------------------------------------------------------
; // function:	Wake up from Sleep Mode
; // description:	Must be done after WakeUp Interupt from the MCP
; //              when the MCP is in Sleep Mode
; //-----------------------------------------------------------------------------
; void CAN_Wake_up ( void )
; {
	.dbline 310
;    CAN_WriteRegister(MCP_CANINTF, CANINTF_ALL_DISABLE );
	clr R18
	ldi R16,44
	xcall _CAN_WriteRegister
	.dbline -2
L20:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e CAN_Tx0 _CAN_Tx0 fV
;            DTA -> y+12
;            DLC -> y+10
;         EXT_ID -> y+8
;         CAN_ID -> y+4
	.even
_CAN_Tx0::
	xcall push_arg4
	sbiw R28,4
	.dbline -1
	.dbline 318
; }
; 
; //-----------------------------------------------------------------------------
; // function:	Transmit Message  TX0
; // description:	
; //-----------------------------------------------------------------------------
; void CAN_Tx0 ( DWORD CAN_ID, BYTE EXT_ID, BYTE DLC, BYTE *DTA)
; {
	.dbline 322
;   //MCP_WriteRegister (TXB0SIDL,CAN_ID_LOW); //Std-IDentifyer low
;   //MCP_WriteRegister (TXB0SIDH,CAN_ID_HIGH); //Std-IDentifyer hi
;   
;   if( DLC > 8 )
	ldi R24,8
	ldd R0,y+10
	cp R24,R0
	brsh L22
	.dbline 323
;      return;
	xjmp L21
L22:
	.dbline 325
;      
;   CAN_Write_Can_ID( MCP_TXB0SIDH, EXT_ID, CAN_ID );
	movw R30,R28
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldd R18,y+8
	ldi R16,49
	xcall _CAN_Write_Can_ID
	.dbline 326
;   CAN_WriteRegister (MCP_TXB0DLC,DLC); //Data length
	ldd R18,y+10
	ldi R16,53
	xcall _CAN_WriteRegister
	.dbline 327
;   CAN_WriteManyRegisters (MCP_TXB0D0,DLC,DTA);
	ldd R0,y+12
	ldd R1,y+13
	std y+1,R1
	std y+0,R0
	ldd R18,y+10
	ldi R16,54
	xcall _CAN_WriteManyRegisters
	.dbline 328
;   CAN_WriteRegister (MCP_TXB0CTRL,0b00001011); // Tx-Ctr
	ldi R18,11
	ldi R16,48
	xcall _CAN_WriteRegister
	.dbline -2
L21:
	adiw R28,8
	.dbline 0 ; func end
	ret
	.dbsym l DTA 12 pc
	.dbsym l DLC 10 c
	.dbsym l EXT_ID 8 c
	.dbsym l CAN_ID 4 l
	.dbend
	.dbfunc e CAN_Tx1 _CAN_Tx1 fV
;            DTA -> y+12
;            DLC -> y+10
;         EXT_ID -> y+8
;         CAN_ID -> y+4
	.even
_CAN_Tx1::
	xcall push_arg4
	sbiw R28,4
	.dbline -1
	.dbline 345
; //  do
; 
; //  {
; 
; //    notsend = (0x08 & MCP_ReadRegister(TXB0CTRL));
; 
; //  } 
; 
; //  while (notsend == 0x00);
; 
; }
; //-----------------------------------------------------------------------------
; // function:	Transmit Message  TX1
; // description:	
; //-----------------------------------------------------------------------------
; void CAN_Tx1 ( DWORD CAN_ID, BYTE EXT_ID, BYTE DLC, BYTE *DTA)
; {
	.dbline 349
;   //MCP_WriteRegister (TXB0SIDL,CAN_ID_LOW); //Std-IDentifyer low
;   //MCP_WriteRegister (TXB0SIDH,CAN_ID_HIGH); //Std-IDentifyer hi
;   
;   CAN_Write_Can_ID( MCP_TXB1SIDH, EXT_ID, CAN_ID );
	movw R30,R28
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldd R18,y+8
	ldi R16,65
	xcall _CAN_Write_Can_ID
	.dbline 350
;   CAN_WriteRegister (MCP_TXB1DLC,DLC); //Data length
	ldd R18,y+10
	ldi R16,69
	xcall _CAN_WriteRegister
	.dbline 351
;   CAN_WriteManyRegisters (MCP_TXB1D0,DLC,DTA);
	ldd R0,y+12
	ldd R1,y+13
	std y+1,R1
	std y+0,R0
	ldd R18,y+10
	ldi R16,70
	xcall _CAN_WriteManyRegisters
	.dbline 352
;   CAN_WriteRegister (MCP_TXB1CTRL,0b00001011); // Tx-Ctr
	ldi R18,11
	ldi R16,64
	xcall _CAN_WriteRegister
	.dbline -2
L24:
	adiw R28,8
	.dbline 0 ; func end
	ret
	.dbsym l DTA 12 pc
	.dbsym l DLC 10 c
	.dbsym l EXT_ID 8 c
	.dbsym l CAN_ID 4 l
	.dbend
	.dbfunc e CAN_Tx2 _CAN_Tx2 fV
;            DTA -> y+12
;            DLC -> y+10
;         EXT_ID -> y+8
;         CAN_ID -> y+4
	.even
_CAN_Tx2::
	xcall push_arg4
	sbiw R28,4
	.dbline -1
	.dbline 359
; }
; //-----------------------------------------------------------------------------
; // function:	Transmit Message  TX2
; // description:	
; //-----------------------------------------------------------------------------
; void CAN_Tx2 ( DWORD CAN_ID, BYTE EXT_ID, BYTE DLC, BYTE *DTA)
; {
	.dbline 363
;   //MCP_WriteRegister (TXB0SIDL,CAN_ID_LOW); //Std-IDentifyer low
;   //MCP_WriteRegister (TXB0SIDH,CAN_ID_HIGH); //Std-IDentifyer hi
;   
;   CAN_Write_Can_ID( MCP_TXB2SIDH, EXT_ID, CAN_ID );
	movw R30,R28
	ldd R2,z+4
	ldd R3,z+5
	ldd R4,z+6
	ldd R5,z+7
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	ldd R18,y+8
	ldi R16,81
	xcall _CAN_Write_Can_ID
	.dbline 364
;   CAN_WriteRegister (MCP_TXB2DLC,DLC); //Data length
	ldd R18,y+10
	ldi R16,85
	xcall _CAN_WriteRegister
	.dbline 365
;   CAN_WriteManyRegisters (MCP_TXB2D0,DLC,DTA);
	ldd R0,y+12
	ldd R1,y+13
	std y+1,R1
	std y+0,R0
	ldd R18,y+10
	ldi R16,86
	xcall _CAN_WriteManyRegisters
	.dbline 366
;   CAN_WriteRegister (MCP_TXB2CTRL,0b00001011); // Tx-Ctr
	ldi R18,11
	ldi R16,80
	xcall _CAN_WriteRegister
	.dbline -2
L25:
	adiw R28,8
	.dbline 0 ; func end
	ret
	.dbsym l DTA 12 pc
	.dbsym l DLC 10 c
	.dbsym l EXT_ID 8 c
	.dbsym l CAN_ID 4 l
	.dbend
	.dbfunc e CAN_Rx0 _CAN_Rx0 fV
;            DTA -> y+8
;            DLC -> y+6
;         EXT_ID -> R10,R11
;         CAN_ID -> R12,R13
	.even
_CAN_Rx0::
	xcall push_gset4x
	movw R10,R18
	movw R12,R16
	sbiw R28,2
	.dbline -1
	.dbline 373
; }    
; //-----------------------------------------------------------------------------
; // function:	Receive Message from Buffer 0
; // description:	read Message and clear Flag
; //-----------------------------------------------------------------------------
; void CAN_Rx0 ( DWORD *CAN_ID, BYTE *EXT_ID, BYTE *DLC, BYTE *DTA)
; {
	.dbline 380
;    // Recieve from Rx0
;    //WORD int_state;
;    //WORD new_int_state;
; 
;   //*CAN_ID_HIGH = MCP_ReadRegister(RXB0SIDH);
;   //*CAN_ID_LOW  = MCP_ReadRegister(RXB0SIDL);
;   CAN_Read_Can_ID( MCP_RXB0SIDH, EXT_ID, CAN_ID ); 
	std y+1,R13
	std y+0,R12
	movw R18,R10
	ldi R16,97
	xcall _CAN_Read_Can_ID
	.dbline 381
;   *DLC = CAN_ReadRegister(MCP_RXB0DLC);
	ldi R16,101
	xcall _CAN_ReadRegister
	mov R2,R16
	ldd R30,y+6
	ldd R31,y+7
	std z+0,R2
	.dbline 382
;   CAN_ReadManyRegisters(MCP_RXB0D0,*DLC,DTA);
	ldd R0,y+8
	ldd R1,y+9
	std y+1,R1
	std y+0,R0
	ldd R18,z+0
	ldi R16,102
	xcall _CAN_ReadManyRegisters
	.dbline -2
L26:
	adiw R28,2
	xcall pop_gset4x
	.dbline 0 ; func end
	ret
	.dbsym l DTA 8 pc
	.dbsym l DLC 6 pc
	.dbsym r EXT_ID 10 pc
	.dbsym r CAN_ID 12 pl
	.dbend
	.dbfunc e CAN_Rx1 _CAN_Rx1 fV
;            DTA -> y+8
;            DLC -> y+6
;         EXT_ID -> R10,R11
;         CAN_ID -> R12,R13
	.even
_CAN_Rx1::
	xcall push_gset4x
	movw R10,R18
	movw R12,R16
	sbiw R28,2
	.dbline -1
	.dbline 390
; }
; 
; //-----------------------------------------------------------------------------
; // function:	Receive Message from Buffer 1
; // description:	read Message and clear Flag
; //-----------------------------------------------------------------------------
; void CAN_Rx1 (DWORD *CAN_ID, BYTE *EXT_ID, BYTE *DLC, BYTE *DTA)
; {
	.dbline 397
;    // Recieve from Rx1
;    //WORD int_state;
;    //WORD new_int_state;
; 
;    //*CAN_ID_HIGH = MCP_ReadRegister(RXB1SIDH);
;    //*CAN_ID_LOW  = MCP_ReadRegister(RXB1SIDL);
;    CAN_Read_Can_ID( MCP_RXB1SIDH, EXT_ID, CAN_ID ); 
	std y+1,R13
	std y+0,R12
	movw R18,R10
	ldi R16,113
	xcall _CAN_Read_Can_ID
	.dbline 398
;    *DLC = CAN_ReadRegister(MCP_RXB1DLC);
	ldi R16,117
	xcall _CAN_ReadRegister
	mov R2,R16
	ldd R30,y+6
	ldd R31,y+7
	std z+0,R2
	.dbline 399
;    CAN_ReadManyRegisters(MCP_RXB1D0,*DLC,DTA);
	ldd R0,y+8
	ldd R1,y+9
	std y+1,R1
	std y+0,R0
	ldd R18,z+0
	ldi R16,118
	xcall _CAN_ReadManyRegisters
	.dbline -2
L27:
	adiw R28,2
	xcall pop_gset4x
	.dbline 0 ; func end
	ret
	.dbsym l DTA 8 pc
	.dbsym l DLC 6 pc
	.dbsym r EXT_ID 10 pc
	.dbsym r CAN_ID 12 pl
	.dbend
	.dbfunc e CAN_Read_Can_ID _CAN_Read_Can_ID fV
;       tbufdata -> y+2
;         can_id -> R12,R13
;            ext -> R10,R11
;       mcp_addr -> R14
	.even
_CAN_Read_Can_ID::
	xcall push_gset5x
	movw R10,R18
	mov R14,R16
	sbiw R28,6
	ldd R12,y+12
	ldd R13,y+13
	.dbline -1
	.dbline 406
	.dbline 409
	clr R2
	movw R30,R10
	std z+0,R2
	.dbline 410
	ldi R24,0
	ldi R25,0
	ldi R26,0
	ldi R27,0
	movw R30,R12
	std z+0,R24
	std z+1,R25
	std z+2,R26
	std z+3,R27
	.dbline 411
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,4
	mov R16,R14
	xcall _CAN_ReadManyRegisters
	.dbline 412
	ldi R18,5
	ldi R19,0
	ldd R16,y+3
	clr R17
	xcall asr16
	ldd R2,y+2
	clr R3
	lsl R2
	rol R3
	lsl R2
	rol R3
	lsl R2
	rol R3
	add R2,R16
	adc R3,R17
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	movw R30,R12
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
	.dbline 413
	ldd R24,y+3
	andi R24,8
	cpi R24,8
	breq X0
	xjmp L30
X0:
	.dbline 413
	.dbline 414
	ldi R24,2
	ldi R25,0
	st -y,R24
	movw R16,R2
	movw R18,R4
	xcall lsl32
	movw R2,R16
	movw R4,R18
	ldd R24,y+3
	clr R25
	andi R24,3
	andi R25,0
	movw R6,R24
	clr R8
	sbrc R7,7
	com R8
	clr R9
	sbrc R8,7
	com R9
	add R2,R6
	adc R3,R7
	adc R4,R8
	adc R5,R9
	movw R30,R12
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
	.dbline 415
	movw R4,R2
	clr R2
	clr R3
	std z+0,R2
	std z+1,R3
	std z+2,R4
	std z+3,R5
	.dbline 416
	ldd R2,y+4
	clr R3
	mov R3,R2
	clr R2
	clr R4
	sbrc R3,7
	com R4
	clr R5
	sbrc R4,7
	com R5
	ldd R6,z+0
	ldd R7,z+1
	ldd R8,z+2
	ldd R9,z+3
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	ldd R2,y+5
	clr R3
	clr R4
	clr R5
	add R6,R2
	adc R7,R3
	adc R8,R4
	adc R9,R5
	std z+0,R6
	std z+1,R7
	std z+2,R8
	std z+3,R9
	.dbline 417
	ldi R24,1
	movw R30,R10
	std z+0,R24
	.dbline 418
L30:
	.dbline -2
L28:
	adiw R28,6
	xcall pop_gset5x
	.dbline 0 ; func end
	ret
	.dbsym l tbufdata 2 A[4:4]c
	.dbsym r can_id 12 pl
	.dbsym r ext 10 pc
	.dbsym r mcp_addr 14 c
	.dbend
	.dbfunc e CAN_Write_Can_ID _CAN_Write_Can_ID fV
;          canid -> R12,R13
;       tbufdata -> y+2
;         can_id -> y+12
;            ext -> R14
;       mcp_addr -> R10
	.even
_CAN_Write_Can_ID::
	xcall push_gset5x
	mov R14,R18
	mov R10,R16
	sbiw R28,6
	.dbline -1
	.dbline 425
; }
; //-----------------------------------------------------------------------------
; // function:	read CAN-ID std. or Ext
; // description:	read can-id
; //-----------------------------------------------------------------------------
; void CAN_Read_Can_ID( BYTE mcp_addr, BYTE* ext, DWORD* can_id )
; {
;     BYTE tbufdata[4];
;     
;     *ext = 0;
;     *can_id = 0;
;     CAN_ReadManyRegisters( mcp_addr, 4, tbufdata );
;     *can_id = (tbufdata[SIDH]<<3) + (tbufdata[SIDL]>>5);
;     if ( (tbufdata[SIDL] & TXBnSIDL_EXIDE) ==  TXBnSIDL_EXIDE ) {
;         *can_id = (*can_id<<2) + (tbufdata[SIDL] & 0x03);
;         *can_id <<= 16;
;         *can_id = *can_id +(tbufdata[EID8]<<8) + tbufdata[EID0];
;         *ext = 1;
;     }
; }
; //-----------------------------------------------------------------------------
; // function:	write CAN-ID std. or Ext
; // description:	write can-id
; //-----------------------------------------------------------------------------
; void CAN_Write_Can_ID( BYTE mcp_addr, BYTE ext, DWORD can_id )
; {
	.dbline 429
;     WORD canid;
;     BYTE tbufdata[4];
;     
;     canid = (WORD)(can_id & 0x0FFFF);
	ldi R24,255
	ldi R25,255
	ldi R26,0
	ldi R27,0
	movw R30,R28
	ldd R2,z+12
	ldd R3,z+13
	ldd R4,z+14
	ldd R5,z+15
	and R2,R24
	and R3,R25
	and R4,R26
	and R5,R27
	movw R12,R2
	.dbline 430
;     if ( ext == 1) {
	mov R24,R14
	cpi R24,1
	brne L37
	.dbline 430
	.dbline 431
;         tbufdata[EID0] = (BYTE) (canid & 0xFF);
	movw R24,R2
	andi R25,0
	std y+5,R24
	.dbline 432
;         tbufdata[EID8] = (BYTE) (canid / 256);
	mov R2,R3
	clr R3
	std y+4,R2
	.dbline 433
;         canid = (WORD)( can_id / 0x10000L );
	movw R30,R28
	ldd R2,z+12
	ldd R3,z+13
	ldd R4,z+14
	ldd R5,z+15
	movw R12,R4
	.dbline 434
;         tbufdata[SIDL] = (BYTE) (canid & 0x03);
	movw R24,R12
	andi R24,3
	andi R25,0
	std y+3,R24
	.dbline 435
;         tbufdata[SIDL] += (BYTE) ((canid & 0x1C )*8);
	movw R18,R12
	andi R18,28
	andi R19,0
	ldi R16,8
	ldi R17,0
	xcall empy16s
	ldd R2,y+3
	add R2,R16
	std y+3,R2
	.dbline 436
;         tbufdata[SIDL] |= TXBnSIDL_EXIDE;
	mov R24,R2
	ori R24,8
	std y+3,R24
	.dbline 437
;         tbufdata[SIDH] = (BYTE) (canid / 32 );
	ldi R18,5
	ldi R19,0
	movw R16,R12
	xcall lsr16
	std y+2,R16
	.dbline 438
;     }
	xjmp L38
L37:
	.dbline 439
;     else {
	.dbline 440
;         tbufdata[SIDH] = (BYTE) (canid / 8 );
	movw R2,R12
	lsr R3
	ror R2
	lsr R3
	ror R2
	lsr R3
	ror R2
	std y+2,R2
	.dbline 441
;         tbufdata[SIDL] = (BYTE) ((canid & 0x07 )*32);
	movw R18,R12
	andi R18,7
	andi R19,0
	ldi R16,32
	ldi R17,0
	xcall empy16s
	std y+3,R16
	.dbline 442
;         tbufdata[EID0] = 0;
	clr R2
	std y+5,R2
	.dbline 443
;         tbufdata[EID8] = 0;
	std y+4,R2
	.dbline 444
;     }
L38:
	.dbline 445
;     CAN_WriteManyRegisters( mcp_addr, 4, tbufdata );
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,4
	mov R16,R10
	xcall _CAN_WriteManyRegisters
	.dbline -2
L36:
	adiw R28,6
	xcall pop_gset5x
	.dbline 0 ; func end
	ret
	.dbsym r canid 12 s
	.dbsym l tbufdata 2 A[4:4]c
	.dbsym l can_id 12 l
	.dbsym r ext 14 c
	.dbsym r mcp_addr 10 c
	.dbend
	.dbfunc e CAN_Chk _CAN_Chk fc
;         Buffer -> R10
	.even
_CAN_Chk::
	xcall push_gset3x
	.dbline -1
	.dbline 455
; }
; //-----------------------------------------------------------------------------
; // function:	Check Messages
; // description:	is neq 0 if any RX-Buffer is not empty
; //              returns 0x01 for Buffer0
; //                      0x02 for Buffer1
; //			0x03 for both Buffers
; //-----------------------------------------------------------------------------
; BYTE CAN_Chk (void)
; {
	.dbline 456
;   BYTE Buffer=0;
	clr R10
	.dbline 457
;   Buffer = CAN_ReadRegister ( MCP_CANINTF );
	ldi R16,44
	xcall _CAN_ReadRegister
	mov R10,R16
	.dbline 458
;   return (Buffer & 0x03);
	andi R16,3
	.dbline -2
L47:
	xcall pop_gset3x
	.dbline 0 ; func end
	ret
	.dbsym r Buffer 10 c
	.dbend
	.dbfunc e CAN_IntClear _CAN_IntClear fV
	.even
_CAN_IntClear::
	.dbline -1
	.dbline 466
; }
; 
; //-----------------------------------------------------------------------------
; // function:	Clear Interrupts 
; // description:	
; //-----------------------------------------------------------------------------
; void CAN_IntClear (void)
; {
	.dbline 467
;    CAN_WriteRegister( MCP_CANINTF, CANINTF_ALL_DISABLE );
	clr R18
	ldi R16,44
	xcall _CAN_WriteRegister
	.dbline -2
L48:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e CAN_ClearRX0 _CAN_ClearRX0 fV
	.even
_CAN_ClearRX0::
	sbiw R28,1
	.dbline -1
	.dbline 475
; }
; 
; //-----------------------------------------------------------------------------
; // function:	Clear Interrupt Flag RX0
; // description:	
; //-----------------------------------------------------------------------------
; void CAN_ClearRX0 (void)
; {
	.dbline 476
;      CAN_ModifyRegister ( MCP_CANINTF, CANINTF_RX0IF, 0x00 );
	clr R2
	std y+0,R2
	ldi R18,1
	ldi R16,44
	xcall _CAN_ModifyRegister
	.dbline -2
L49:
	adiw R28,1
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e CAN_ClearRX1 _CAN_ClearRX1 fV
	.even
_CAN_ClearRX1::
	sbiw R28,1
	.dbline -1
	.dbline 490
; //   unsigned int int_reg;
; 
; //   int_reg = MCP_ReadRegister(CANINTF);
; //   int_reg = int_reg & 0xFE;
; //   MCP_WriteRegister(CANINTF,int_reg);
; 
; }
; 
; //-----------------------------------------------------------------------------
; // function:	Clear Interrupt Flag RX1
; // description:	
; //-----------------------------------------------------------------------------
; void CAN_ClearRX1 (void)
; {
	.dbline 491
;      CAN_ModifyRegister ( MCP_CANINTF, CANINTF_RX1IF, 0x00 );
	clr R2
	std y+0,R2
	ldi R18,2
	ldi R16,44
	xcall _CAN_ModifyRegister
	.dbline -2
L50:
	adiw R28,1
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e SPI_mcp_select _SPI_mcp_select fV
	.even
_SPI_mcp_select::
	.dbline -1
	.dbline 510
; //   unsigned int int_reg;
; 
; //   int_reg = MCP_ReadRegister(CANINTF);
; //   int_reg = int_reg & 0xFD;
; //   MCP_WriteRegister(CANINTF,int_reg);
; 
; }
; 
; //-----------------------------------------------------------------------------
; //- Local Functionen
; //-----------------------------------------------------------------------------
; //
; //-----------------------------------------------------------------------------
; // Selects the MCP2515.
; // Note: mcpCS is set to zero also by SPI_mcp_RD_address(),
; // SPI_mcp_WR_address() and SPI_mcp_RD_status().
; //-----------------------------------------------------------------------------
; void SPI_mcp_select (void)
; {
	.dbline 511
;    RettConf = SPCR;         // alte Config retten
	in R2,0xd
	sts _RettConf,R2
	.dbline 512
;    SPCR = SPI_MCP_WR;	    // neue SPI Config
	ldi R24,80
	out 0xd,R24
	.dbline 514
;     	
;    CBI( CAN_PORT_CS, CS_CAN );    //- CS_CAN low 
	ldi R17,250
	ldi R16,1
	xcall lsl8
	in R2,0x12
	and R2,R16
	out 0x12,R2
	.dbline -2
L51:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e SPI_mcp_unselect _SPI_mcp_unselect fV
	.even
_SPI_mcp_unselect::
	.dbline -1
	.dbline 521
; }
; //-----------------------------------------------------------------------------
; // To avoid a bug, SCK must be low when CS is raising. But thing doesn't work
; // if CKP remains low, so we set it to 1 as soon as CS is 1.
; //-----------------------------------------------------------------------------
; void SPI_mcp_unselect (void)
; {
	.dbline 522
;      SBI( CAN_PORT_CS, CS_CAN ); //- CS_CAN high 
	sbi 0x12,5
	.dbline 524
;      
;      SPCR = RettConf;            //- Config SPI zurueck
	lds R2,_RettConf
	out 0xd,R2
	.dbline -2
L52:
	.dbline 0 ; func end
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\icc\examples.avr\MCP2515\source\mcp2515.c
_RettConf:
	.blkb 1
	.dbsym s RettConf _RettConf c
