	.module spi.c
	.area text(rom, con, rel)
	.dbfile C:\icc\examples.avr\MCP2515\source\spi.c
	.dbfunc e SpiInit _SpiInit fV
; ControlRegister -> R16
	.even
_SpiInit::
	.dbline -1
	.dbline 14
; 
; 
; #include "hw.h"
; #include "spi.h"
; 
; /*
; **  SpiInit() initializes the SPI as a master, enable it
; **  and set it up as requested by parameter Controlregister.
; **  See "spi.h" for availible parameter values, they could
; **  be ORed together. See AVR SPI documentation for more 
; **  detailed information.
; */
; void SpiInit(unsigned char ControlRegister)
; {
	.dbline 15
;     DDRB  |= 0xB0;  // Set SCK, MOSI & SS as outputs
	in R24,0x17
	ori R24,176
	out 0x17,R24
	.dbline 16
;     PORTB &= 0x5F;  // clear bits MOSI, & SCK
	in R24,0x18
	andi R24,95
	out 0x18,R24
	.dbline 18
; 
;     SPCR = ControlRegister + SPE + MSTR;    // Write to control register.
	mov R24,R16
	subi R24,246    ; addi 10
	out 0xd,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r ControlRegister 16 c
	.dbend
	.dbfunc e SpiWriteByte _SpiWriteByte fV
;           byte -> R16
	.even
_SpiWriteByte::
	.dbline -1
	.dbline 27
; }
; 
; /*
; **  SpiWriteByte() writes a byte to the SPI and waits until
; **  it has been transmitted. This function doesn't
; **  return any value back.
; */
; void SpiWriteByte(unsigned char byte)
; {
	.dbline 28
;     SPDR = byte;
	out 0xf,R16
L3:
	.dbline 29
L4:
	.dbline 29
;     while (!(SPSR & 0x80));
	sbis 0xe,7
	rjmp L3
	.dbline 30
;     byte = SPDR;
	in R16,0xf
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbsym r byte 16 c
	.dbend
	.dbfunc e SpiReadByte _SpiReadByte fc
	.even
_SpiReadByte::
	.dbline -1
	.dbline 40
; }
; 
; /*
; **  SpiReadByte() first writes a byte (a dummy, since
; **  that byte is to generate clock signals to "poll" home
; **  the byte from the slave. The function returns the
; **  received byte.
; */
; unsigned char SpiReadByte(void)
; {
	.dbline 41
;     SPDR = 0x00;
	clr R2
	out 0xf,R2
L7:
	.dbline 42
L8:
	.dbline 42
;     while (!(SPSR & 0x80));
	sbis 0xe,7
	rjmp L7
	.dbline 43
;     return SPDR;
	in R16,0xf
	.dbline -2
L6:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e SpiReadDataReg _SpiReadDataReg fc
	.even
_SpiReadDataReg::
	.dbline -1
	.dbline 52
; }
; 
; /*
; **  SpiReadDataReg() reads the last byte in the SPI register
; **  without any clock signals generated. Could be used
; **  as reading the last byte received.
; */
; unsigned char SpiReadDataReg(void)
; {
	.dbline 53
;     return SPDR;
	in R16,0xf
	.dbline -2
L10:
	.dbline 0 ; func end
	ret
	.dbend
