/******************************************************************************
*                              Steffen Hofmann                                *
*                                 Hamburg                                     *
*                               mc_sho@gmx.de                                 *
*******************************************************************************
*  $Source: $
*-----------------------------------------------------------------------------*
*  Datum der 1. Version  :  08.07.2003
*  Geraete Bezeichnung   :  MEGA-128-BOARD
*-----------------------------------------------------------------------------*
*- $Id: $
*-----------------------------------------------------------------------------*
*
*       Source
*       ----------
*       main.c
*       V1.00
******************************************************************************/

#include "baugrid.h"
#include "hw.h"
#include "mcp2515.h"
#include "spi.h"

#define CAN_MODUL     MODUL_FMUSTER

#define CAN_ADR_TEMP  ( DWORD)((CAN_MODUL << 24 ) | ( TEMPERATUR1_ID << 16 ))
#define CAN_ADR_LCD   ( DWORD)((CAN_MODUL << 24 ) | ( LCD_ID << 16 ))

#define MAX_CAN_DATA 8

BYTE can_array[MAX_CAN_DATA];

void initport( void )
{
           
}

void main( void )
{
    BYTE Status;    
    DWORD canID;
    BYTE  extID;
    BYTE dlc;
        
        initport();
        SpiInit( SPI_MCP_WR );
        
        //- Init CAN-Controller
        CAN_Init (0,SPEED_500_CNF1,SPEED_500_CNF2,SPEED_500_CNF3);
        //- Transmit CAN-Message
        //CAN_Tx0 ( CAN_ADR_TEMP, CAN_EXT_ID, MAX_CAN_DATA, can_array);
        
        
        while(1)
        {
             Status = CAN_Chk();
             
             switch( Status )
             {
                case CANINTF_RX0IF:  
                           //- Echo Test
                           CAN_Rx0( &canID, &extID, &dlc, can_array);
                           CAN_ClearRX0();   
                           CAN_Tx0 ( canID, extID, dlc, can_array);
                break;
                case CANINTF_RX1IF:
                           //- Echo Test
                           CAN_Rx1( &canID, &extID, &dlc, can_array);
                           CAN_ClearRX1();
                           CAN_Tx1 ( canID, extID, dlc, can_array);
                break;
                default:  // for error  
                break;             
             }        
        }
        
        
}